import pygame
import sys
import pygame.locals
from random import shuffle

class Gfx:
    last_image_num = -1
    last_row = -1
    last_col = -1
  
    def __init__(self):
        list = sys.argv[1:] 
        if len(list) != 8:
            print "Bitte eine liste Bilder angeben, zum Beispiel"
            print sys.argv[0], "Bild1.png Bild2.png ..."
            print "oder"
            print sys.argv[0], " pics/*"
            print "wobei es genau 8 Bilder sein muessen und die laengste Kante des Bildes hoechstens 200 Pixel gross ist."
            sys.exit(-1)
        self.window = pygame.display.set_mode((800, 800))
        pygame.display.set_caption('Memory')
        self.screen = pygame.display.get_surface() 
        self.blanc_pic = pygame.image.load("0.png").convert()
        self.bild = []
        for name in list:
            pic = pygame.image.load(name).convert()
            self.bild.append([pic, False])
        for i in range(4):
            self.screen.blit(self.blanc_pic, (i * 200, 0)) 
            self.screen.blit(self.blanc_pic, (i * 200, 200)) 
            self.screen.blit(self.blanc_pic, (i * 200, 400)) 
            self.screen.blit(self.blanc_pic, (i * 200, 600))  
        pygame.display.flip()
        self.posis = range(8) + range(8)
        shuffle(self.posis)

    def show_image(self, a_col, a_row):
        img_num = self.posis[a_row * 4 + a_col]
        img, is_shown = self.bild[img_num]
        if self.last_image_num == -1:
        #   erste Karte eines Tupels wird gezogen
            self.last_image_num = img_num
            self.last_row = a_row
            self.last_col = a_col
            self.screen.blit(img, (a_col * 200, a_row * 200))
        elif (self.last_image_num == img_num) and ((self.last_row != a_row) or (self.last_col != a_col)):
        #   Zweite Karte wird gezogen, sie passt zu einem Paar
            self.bild[img_num][1] = True
            self.last_image_num = -1
            self.last_row = -1
            self.last_col = -1
            self.screen.blit (img, (a_col * 200, a_row * 200))
        elif self.last_image_num != img_num:
        #   dieses ist kein pasendes Tupel
            self.screen.blit (img, (a_col * 200, a_row * 200))
            pygame.display.flip ()
            pygame.time.delay(1000)
            self.screen.blit (self.blanc_pic, (a_col * 200, a_row * 200))
            self.screen.blit(self.blanc_pic, (self.last_col * 200, self.last_row * 200)) 
            self.last_image_num = -1
            self.last_row = -1
            self.last_col = -1
        pygame.display.flip()
        self.finished()

    def finished (self):
        count = 0
        for i,j in self.bild:
            if j:
                count = count + 1
        if count == 8:
        # wir sind fertig und blenden noch ein kleines Gimick ein
            for i in range (40):
                pygame.time.delay(100)
                s = pygame.transform.rotozoom(self.screen, i * 1.0, 0.9)
                self.screen.blit(s, (0, 0))
                pygame.display.flip()
            pygame.time.delay(1000)
            sys.exit(0)

class Game:
    def __init__(self):
        self.gfx = Gfx()
        self.game_loop()

    def game_loop (self):
        while True:
            events = pygame.event.get()
            for event in events: 
                if event.type == pygame.QUIT: 
                    sys.exit(0) 
                elif event.type == pygame.MOUSEBUTTONDOWN:
                    x, y = event.pos
                    x = x // 200
                    y = y // 200
                    r = range(4)
                    if (x in r) and (y in r):
                        self.gfx.show_image (x, y)

game = Game ()
