"""Read an XML File and list the Elements and Attributes"""

import sys
from xml.dom.minidom import parse, Node

def listelem (elem, prefix) :
  print "%sElement %s" % ( prefix, elem.tagName )
  prefix = "  " + prefix
  attrs = elem.attributes
  nattrs = attrs.length
  i = 0
  while (i < nattrs) :
    attr = attrs.item (i)
    print "%sAttribute %s = %s" % ( prefix, attr.name, attr.value )
    i += 1
  children = elem.childNodes
  for child in children :
    if (child.nodeType == Node.ELEMENT_NODE) :
      listelem (child, prefix)

def listdoc (fobj) :
  dom = parse (fobj)
  root = dom.documentElement
  listelem (root, "")
  dom.unlink ()

for fname in sys.argv [1 :] :
  fobj = file (fname, "r")
  listdoc (fobj)
  fobj.close ()
